﻿Imports MindFusion.Charting.Wpf

Class Window1

   
    Private r As Random = New Random()
    Private brushesList As List(Of Brush)
    Private unlock As Boolean

    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        Background = New LinearGradientBrush(Colors.SteelBlue, Colors.White, 0)
       



        barChart3D.Series.Clear()

        'Initialize data		
        brushesList = New List(Of Brush)
        Dim t As Byte = 200
        brushesList.Add(New SolidColorBrush(Color.FromArgb(t, Brushes.DodgerBlue.Color.R, Brushes.DodgerBlue.Color.G, Brushes.DodgerBlue.Color.B)))
        brushesList.Add(New SolidColorBrush(Color.FromArgb(t, Brushes.Brown.Color.R, Brushes.Brown.Color.G, Brushes.Brown.Color.B)))
        brushesList.Add(New SolidColorBrush(Color.FromArgb(t, Brushes.Orange.Color.R, Brushes.Orange.Color.G, Brushes.Orange.Color.B)))
        brushesList.Add(New SolidColorBrush(Color.FromArgb(t, Brushes.Yellow.Color.R, Brushes.Yellow.Color.G, Brushes.Yellow.Color.B)))
        brushesList.Add(New SolidColorBrush(Color.FromArgb(t, Brushes.Green.Color.R, Brushes.Green.Color.G, Brushes.Green.Color.B)))
        brushesList.Add(New SolidColorBrush(Color.FromArgb(t, Brushes.Azure.Color.R, Brushes.Azure.Color.G, Brushes.Azure.Color.B)))
        brushesList.Add(New SolidColorBrush(Color.FromArgb(t, Brushes.LightSteelBlue.Color.R, Brushes.LightSteelBlue.Color.G, Brushes.LightSteelBlue.Color.B)))
        brushesList.Add(New SolidColorBrush(Color.FromArgb(t, Brushes.SteelBlue.Color.R, Brushes.SteelBlue.Color.G, Brushes.SteelBlue.Color.B)))
        brushesList.Add(New SolidColorBrush(Color.FromArgb(t, Brushes.DarkBlue.Color.R, Brushes.DarkBlue.Color.G, Brushes.DarkBlue.Color.B)))
        brushesList.Add(New SolidColorBrush(Color.FromArgb(t, Brushes.DarkViolet.Color.R, Brushes.DarkViolet.Color.G, Brushes.DarkViolet.Color.B)))

        

        AddSeries()
        unlock = True

        barType3D.SelectedIndex = 0

        barChart3D.YAxisSettings.Interval = 10
        barChart3D.XAxisSettings.Interval = 1



        barChart3D.XAxisSettings.LabelFontSize = 11
        barChart3D.XAxisSettings.LabelOffset = 3
        barChart3D.XAxisSettings.LabelFormat = "0.##"
        barChart3D.XAxisSettings.TitleFontSize = 12
        barChart3D.XAxisSettings.TitleOffset = 5
        barChart3D.XAxisSettings.Tick = 0.5
        barChart3D.XAxisSettings.Title = "Month"

        barChart3D.YAxisSettings.LabelFontSize = 11
        barChart3D.YAxisSettings.LabelOffset = 3
        barChart3D.YAxisSettings.LabelFormat = "0.##"
        barChart3D.YAxisSettings.TitleFontSize = 12
        barChart3D.YAxisSettings.TitleOffset = 5
        barChart3D.YAxisSettings.Tick = 0.5
        barChart3D.YAxisSettings.Title = "Sales"
        barChart3D.SideWallThickness = 0.5
    End Sub

    Private Sub AddSeries()
        Dim d1 As DoubleCollection = New DoubleCollection(New Double() { _
                r.Next(95) + 5, r.Next(95) + 5, r.Next(95) + 5, r.Next(95) + 5})
        Dim d2 As DoubleCollection = New DoubleCollection(New Double() { _
                1, 2, 3, 4})


        Dim index As Integer = barChart3D.Series.Count Mod brushesList.Count

        Dim series As BarSeries = New BarSeries()
        series.Fills.Add(brushesList(index))
        series.BarWidth = barWidthValue.Value
        If Not IsVertical Then
            series.XData = d1
            series.YData = d2
        Else
            series.XData = d2
            series.YData = d1
        End If
        barChart3D.Series.Add(series)

    End Sub

    Private Sub RemoveSeries()
        If barChart3D.Series.Count > 0 Then
            Dim i As Integer = barChart3D.Series.Count - 1
            barChart3D.Series.Remove(barChart3D.Series(i))
        End If
    End Sub

    Public Property IsVertical() As Boolean
        Get
            If barChart3D.BarType3D = MindFusion.Charting.Wpf.BarType3D.Vertical Or _
                barChart3D.BarType3D = MindFusion.Charting.Wpf.BarType3D.VerticalInColumn Or _
                barChart3D.BarType3D = MindFusion.Charting.Wpf.BarType3D.VerticalStack Then
                Return True
            Else
                Return False
            End If
        End Get
        Set(ByVal value As Boolean)
        End Set
    End Property


    Private Sub Update()
        If Not unlock Then
            Return
        End If

        barChart3D.BeginInit()

        Dim switchData As Boolean = False
        Dim index As Integer = barType3D.SelectedIndex
        If (index < 3 And Not IsVertical) Then
            switchData = True
        ElseIf index >= 3 And IsVertical Then
            switchData = True
        End If
        If switchData Then
            Dim t1 As Double = barChart3D.XAxisSettings.Interval
            Dim t2 As Double = barChart3D.YAxisSettings.Interval
            barChart3D.XAxisSettings.Interval = t2
            barChart3D.YAxisSettings.Interval = t1
            For Each series As BarSeries In barChart3D.Series
                Dim d1 As DoubleCollection = series.XData.Clone()
                Dim d2 As DoubleCollection = series.YData.Clone()
                series.XData = d2
                series.YData = d1
            Next
        End If


        If barType3D.SelectedIndex = 0 Then
            barChart3D.BarType3D = MindFusion.Charting.Wpf.BarType3D.Vertical
        End If
        If barType3D.SelectedIndex = 1 Then
            barChart3D.BarType3D = MindFusion.Charting.Wpf.BarType3D.VerticalInColumn
        End If
        If barType3D.SelectedIndex = 2 Then
            barChart3D.BarType3D = MindFusion.Charting.Wpf.BarType3D.VerticalStack
        End If
        If barType3D.SelectedIndex = 3 Then
            barChart3D.BarType3D = MindFusion.Charting.Wpf.BarType3D.Horizontal
        End If
        If barType3D.SelectedIndex = 4 Then
            barChart3D.BarType3D = MindFusion.Charting.Wpf.BarType3D.HorizontalInColumn
        End If
        If barType3D.SelectedIndex = 5 Then
            barChart3D.BarType3D = MindFusion.Charting.Wpf.BarType3D.HorizontalStack
        End If

        barChart3D.SeriesWidth = seriesWidthValue.Value
        barChart3D.ModelWidth = modelWidthValue.Value
        barChart3D.ModelHeight = modelHeightValue.Value
        barChart3D.ModelDepth = modelDepthValue.Value
        barChart3D.CornerRadius3D = cornerRadius3DValue.Value
        If roundCornerType.SelectedIndex = 0 Then
            barChart3D.RoundCornerType = MindFusion.Charting.Wpf.RoundCornerType.Top
        ElseIf roundCornerType.SelectedIndex = 1 Then
            barChart3D.RoundCornerType = MindFusion.Charting.Wpf.RoundCornerType.Bottom
        ElseIf roundCornerType.SelectedIndex = 2 Then
            barChart3D.RoundCornerType = MindFusion.Charting.Wpf.RoundCornerType.All
        ElseIf roundCornerType.SelectedIndex = 3 Then
            barChart3D.RoundCornerType = MindFusion.Charting.Wpf.RoundCornerType.None
        End If

        barChart3D.EndInit()
    End Sub

    Private Sub barValue_ValueChanged(ByVal sender As Object, ByVal e As RoutedPropertyChangedEventArgs(Of Double))
        'For i As Integer = 0 To barChart3D.Series.Count - 1
        '    If IsVertical Then
        '        CType(barChart3D.Series(i), BarSeries).YData(barSelection.SelectedIndex) = barValue.Value
        '    Else
        '        CType(barChart3D.Series(i), BarSeries).XData(barSelection.SelectedIndex) = barValue.Value
        '    End If
        'Next
    End Sub


    Private Sub barType3D_SelectionChanged(ByVal sender As Object, ByVal e As SelectionChangedEventArgs)
        Update()
    End Sub

    Private Sub barSelection_SelectionChanged(ByVal sender As Object, ByVal e As SelectionChangedEventArgs)

    End Sub

    Private Sub Button_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        AddSeries()
    End Sub

    Private Sub Button_Click_1(ByVal sender As Object, ByVal e As RoutedEventArgs)
        RemoveSeries()
    End Sub

    Private Sub seriesWidthValue_ValueChanged(ByVal sender As Object, ByVal e As RoutedPropertyChangedEventArgs(Of Double))
        barChart3D.SeriesWidth = seriesWidthValue.Value
    End Sub

    Private Sub barWidthValue_ValueChanged(ByVal sender As Object, ByVal e As RoutedPropertyChangedEventArgs(Of Double))
        barChart3D.BeginInit()
        For Each series As BarSeries In barChart3D.Series
            series.BarWidth = barWidthValue.Value
        Next
        barChart3D.EndInit()
    End Sub

    Private Sub modelWidthValue_ValueChanged(ByVal sender As Object, ByVal e As RoutedPropertyChangedEventArgs(Of Double))
        barChart3D.ModelWidth = modelWidthValue.Value
    End Sub

    Private Sub modelHeightValue_ValueChanged(ByVal sender As Object, ByVal e As RoutedPropertyChangedEventArgs(Of Double))
        barChart3D.ModelHeight = modelHeightValue.Value
    End Sub

    Private Sub modelDepthValue_ValueChanged(ByVal sender As Object, ByVal e As RoutedPropertyChangedEventArgs(Of Double))
        barChart3D.ModelDepth = modelDepthValue.Value
    End Sub

    Private Sub cornerRadius3DValue_ValueChanged(ByVal sender As Object, ByVal e As RoutedPropertyChangedEventArgs(Of Double))
        barChart3D.CornerRadius3D = cornerRadius3DValue.Value
    End Sub

    Private Sub cornerRadiusType_SelectionChanged(ByVal sender As Object, ByVal e As SelectionChangedEventArgs)
        Update()
    End Sub

    Private Sub behavior_SelectionChanged(ByVal sender As Object, ByVal e As SelectionChangedEventArgs)
        If CType(sender, ComboBox).SelectedIndex = 0 Then
            barChart3D.Behavior = Behavior3D.ChangePerspective
        Else
            barChart3D.Behavior = Behavior3D.ChangeValue
        End If
    End Sub
End Class
